CCC   #################################################################
CCC   corr()
CCC   #################################################################
CCC   last updated 04012013
CCC   modified to test uKK and distrKK 
CCC   in order to compare with those of Otavio's implementation
CCC
CCC   last updated 07142007
CCC   adopt new version according to Yogiro
CCC
CCC   last updated 07082007
CCC   adopt pp0 output
CCC
CCC   last updated 07072007
CCC   modified output
CCC   modified formulae according to Yogiro
CCC
CCC   last updated 07062007
CCC   fix a bug leading to negative distribution
CCC   add output debugging info concerning the recent modification
CCC
CCC   last updated 07052007
CCC   adopt new ce scenario
CCC
CCC   last updated 04122007
CCC   modified the structure in the do loop
CCC   #################################################################
      SUBROUTINE CORR(nfr,rp,k1,k2,xnum,xden,xden1,xden2)     
      IMPLICIT NONE
      INCLUDE 'spherio.inc'
      INCLUDE 'spherio.ce.inc'
      INCLUDE 'spherio.debug.inc'
      INCLUDE 'spherio.evgen1.inc'
      INCLUDE 'spherio.evgen2.inc'
c      INCLUDE 'spherio.evgen1-ic.inc'
      INTEGER nfr
      double precision k1(0:3),k2(0:3),KK(0:3),QQ(0:3),xnum,xden,rp
      double precision xden1,xden2
      INTEGER ipart,id,gg,bb,ii,i
      INTEGER i1,i2
      double precision mm,sinal,x,y,eta,tau
      double precision stau,sx,sy,seta,utau,ux,uy,ueta
      double precision xxx(0:3),sss(0:3),uuu(0:3)
      double precision sk1,uk1,sk2,uk2,somak1,somak2,somare,somaim
      double precision distr1,distr2,QQXX,sKK,sign,Tfff
      double precision distrKK,uKK
      double precision pp,pp0,ssd,pp1,pp2
      double precision nr0,nr1,nr2,nr3
      double precision nnn(0:3),norm
      double precision nk1,nk2
      double precision nuc,uc(0:3)
      INTEGER ioutput
      double precision KK0
      SAVE ioutput
      SAVE KK0

      DO i=0,3
        KK(i)=0.5*(k1(i)+k2(i))
        QQ(i)=k1(i)-k2(i)
      ENDDO

      if (iauxi.ge.7) then
      open(11,FILE='hbtdebug.data',STATUS='NEW',ACCESS='APPEND',ERR=377)
      ioutput=0
      KK0=0.1d0
      close(11)
377   continue      
c      ioutput=ioutput+1
      end if

      ipart = 1 !! pi+
      
      id     = ipid(ipart)
      mm     = mss(id)
      gg     = ngf(id)
      bb     = nbr(id)
      IF(bb.EQ.0)THEN
             sinal = -1.  !! bosons
      ELSE
             sinal = +1.  !! fermions 
      ENDIF

      i1 = INT( (rp-(-almx))/dal )+1
 
      somak1=0.0
      somak2=0.0
      somare=0.0
      somaim=0.0
cxxx      DO ii=1,nfr
      DO 999 i2=i1-RL,i1+RL
         IF(i2.LE.0)  cycle
         IF(i2.GT.LXY) cycle
         ii = hda(i2)
900      CONTINUE
         IF(ii.EQ.0) cycle
         x   = xfrs(1,ii)
         y   = xfrs(2,ii)
         eta = xfrs(3,ii)
         tau = xfrs(0,ii)              
c 4-vector x^{\mu} {txyz-coord}
         xxx(0)      = tau*COSH(eta)
         xxx(1)      = x
         xxx(2)      = y
         xxx(3)      = tau*SINH(eta)
c 4-vector s_{\mu} {{\tau}xy{\eta}-coord}
         stau   = sfrs(0,ii)
         sx     = sfrs(1,ii)
         sy     = sfrs(2,ii)
         seta   = sfrs(3,ii)
c 4-vector s_{\mu} {txyz-coord}
         sss(0)     = +COSH(eta)*stau-1./tau*SINH(eta)*seta
         sss(1)     = sx
         sss(2)     = sy
         sss(3)     = -SINH(eta)*stau+1./tau*COSH(eta)*seta
c 4-vector nr_{\mu} {{\tau}xy{\eta}-coord}
         nr0    = nrfz(0,ii)
         nr1    = nrfz(1,ii)
         nr2    = nrfz(2,ii)
         nr3    = nrfz(3,ii)
         norm   = nrfz(4,ii)
c 4-vector nr_{\mu} {txyz-coord}
         nnn(0)     = +COSH(eta)*nr0-1./tau*SINH(eta)*nr3
         nnn(1)     = nr1
         nnn(2)     = nr2
         nnn(3)     = -SINH(eta)*nr0+1./tau*COSH(eta)*nr3
c 4-vector u_{\mu} {{\tau},x,y,{\eta}}-coord}
         utau   = ufrs(0,ii)
         ux     = ufrs(1,ii)
         uy     = ufrs(2,ii)
         ueta   = ufrs(3,ii)
c 4-vector u_{\mu} {txyz-coord}
         uuu(0)     = +COSH(eta)*utau-1./tau*SINH(eta)*ueta
         uuu(1)     = ux
         uuu(2)     = uy
         uuu(3)     = -SINH(eta)*utau+1./tau*COSH(eta)*ueta
c 4-vector u^{\mu} {txyz-coord}
         uc(0)      = +uuu(0)
         uc(1)      = -uuu(1)
         uc(2)      = -uuu(2)
         uc(3)      = -uuu(3)

         sKK=0.0
         sk1=0.0
         uk1=0.0
         sk2=0.0
         uk2=0.0
         nk1=0.0
         nk2=0.0
         nuc=0.0
         uKK=0.0
         DO i=0,3
             sKK=sKK+sss(i)*KK(i)
             uKK=uKK+uuu(i)*KK(i)
             sk1=sk1+sss(i)*k1(i)
             uk1=uk1+uuu(i)*k1(i)
             nk1=nk1+nnn(i)*k1(i)
             sk2=sk2+sss(i)*k2(i)
             uk2=uk2+uuu(i)*k2(i)
             nk2=nk2+nnn(i)*k2(i)
             nuc=nuc+nnn(i)*uc(i)
         ENDDO
         Tfff = tempfz(ii)
         distr1=1.0/( exp(uk1/Tfff)+sinal )
         distr2=1.0/( exp(uk2/Tfff)+sinal ) 
         distrKK=1.0/( exp(uKK/Tfff)+sinal ) 
         select case (icemode)
         case (2)
              pp  = ppfz(ii)
              ssd = ssfz(ii)
              nk1 = nk1*norm
              nk2 = nk2*norm
      		nuc = nuc*norm
              pp0 = exp(-kappa*ssd*ssd/nuc)
              pp1 = exp(-kappa*mm*ssd*ssd/nk1)
              pp2 = exp(-kappa*mm*ssd*ssd/nk2)
      		if (nuc.le.0.d0) pp0=0.d0
      		if (nk1.le.0.d0) pp1=0.d0
      		if (nk2.le.0.d0) pp2=0.d0
              distr1=distr1*pp1/(1.d0-pp1)/pp*(1.d0-pp)
              distr2=distr2*pp2/(1.d0-pp2)/pp*(1.d0-pp)
              if (ioutput.le.100) then
              if (abs(KK0-KK(0))/KK(0).ge.0.3.and.pp.lt.0.98) then
               ioutput=ioutput+1
               KK0=KK(0)
               open(11,FILE='hbtdebug.data',ACCESS='APPEND')
               write(11,'(a,i3)')'ioutput=',ioutput
               write(11,'(a,4d20.10)')'pp,pp0,pp1,pp2=',pp,pp0,pp1,pp2
               write(11,'(a,d20.10)')'norm=',norm
               write(11,'(a,4d20.10)')'nnn=',nnn(0),nnn(1),nnn(2),nnn(3)
               write(11,'(a,4d20.10)')'sss=',sss(0),sss(1),sss(2),sss(3)
               write(11,'(a,4d20.10)')'uuu=',uuu(0),uuu(1),uuu(2),uuu(3)
               write(11,'(a,4d20.10)')'k1=',k1(0),k1(1),k1(2),k1(3)
               write(11,'(a,4d20.10)')'k2=',k2(0),k2(1),k2(2),k2(3)
               write(11,'(a,4d20.10)')'KK=',KK(0),KK(1),KK(2),KK(3)
               close(11)
              end if
              end if
         case default
              continue
         end select
         QQXX = 0.0
         sign=+1.0
         DO i=0,3
              IF(i.NE.0)sign=-1.0
              QQXX=QQXX+sign*QQ(i)*xxx(i) !! [GeV*fm]
         ENDDO  
         QQXX = QQXX/hbarc   !! [non]
         IF(sk1.ge.0.0)then
             somak1=somak1+sk1*distr1
         ENDIF
         IF(sk2.ge.0.0)then
             somak2=somak2+sk2*distr2
         ENDIF
         IF(sKK.ge.0.0)then
c               somare=somare+sKK*SQRT(distr1*distr2)*COS(QQXX)
c               somaim=somaim+sKK*SQRT(distr1*distr2)*SIN(QQXX)
               somare=somare+sKK*distrKK*COS(QQXX)
               somaim=somaim+sKK*distrKK*SIN(QQXX)
         ENDIF
c------------
         ii=lta(ii)
         GOTO 900
c------------
 999  CONTINUE   
cxxx      ENDDO 

      xden1 = somak1
      xden2 = somak2
      xden  = somak1*somak2
      xnum  = somare**2+somaim**2

      RETURN
      END
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX




CCC   #################################################################
CCC   evghbt()
CCC   #################################################################
CCC   last updated 07142007
CCC   modified according to Yogiro
CCC
CCC   last updated 06202007
CCC   modified the range for C2 plot
CCC
CCC   last updated 06042007
CCC   fixed a bug
CCC
CCC   last updated 06012007
CCC   modified to decrease ikt number
CCC
CCC   last updated 05102007
CCC   modified the KT windows accroding to PHENIX exp at 200MeV
CCC
CCC   last updated 05082007
CCC   modified the KT windows accroding to STAR experiment at 130MeV
CCC
CCC   last updated 04182007
CCC   modified the output format
CCC
CCC   last updated 04122007
CCC   modified the output sligtly
CCC   #################################################################
      SUBROUTINE evghbt(nfr)
      IMPLICIT NONE
      include 'epos.incsf'
      include 'spherio.seedspo.inc'
      INTEGER nfr
      INTEGER i,j
      double precision KT
      double precision soma1,soma2
      double precision soma3,soma4
      double precision C2,KTmin,KTmax
      double precision k1(0:3),k2(0:3),qs,qo,ql,Y
      double precision qsmin,qsmax,dqs,ran2r
      double precision qomin,qomax,dqo,xnum,xden
      double precision xden1,xden2
      double precision qlmin,qlmax,dql
      double precision delta_qo,delta_ql,delta_qs
      INTEGER nqs,nqo,nql,ikt
C Numero de monte carlo usado na integracao
      INTEGER nmc                  
      PARAMETER (nmc=8000) 
C Se iprnt = 0, entao imprime (q,C2)
C Se iprnt = 1, entao imprime (q,num,den). C2=1+num/den
      INTEGER iprnt
      PARAMETER (iprnt=2)
C For output
      character*9 cktindx
c============================

C... Janela experimental para q_i (deve ser modificado de acordo com a experiencia)
      delta_qo = 0.04  ! [GeV]
      delta_qs = 0.04  ! [GeV]
      delta_ql = 0.04  ! [GeV]
C...

      CALL raplist(nfr)

      OPEN(78,FILE=fnhbt(1:nfnhbt),STATUS='replace')
      OPEN(79,FILE=fnpecc(1:nfnpecc)//'hbtpara.optns',STATUS='replace')

      DO 100 ikt=1,20
      IF(ikt.EQ.1)THEN
CCC   for Au-Au 200 GeV
         KTmin = 0.20
         KTmax = 0.30
CCC   for Au-Au 130 GeV
c         KTmin = 0.125
c         KTmax = 0.225
c      ELSE IF(ikt.EQ.2)THEN
CCC   for Au-Au 200 GeV
c         KTmin = 0.30
c         KTmax = 0.36
CCC   for Au-Au 130 GeV
c         KTmin = 0.225
c         KTmax = 0.325
      ELSE IF(ikt.EQ.3)THEN
CCC   for Au-Au 200 GeV
         KTmin = 0.36
         KTmax = 0.42
CCC   for Au-Au 130 GeV
c         KTmin = 0.325
c         KTmax = 0.45
c      ELSE IF(ikt.EQ.4)THEN
CCC   for Au-Au 200 GeV
c         KTmin = 0.42
c         KTmax = 0.48
      ELSE IF(ikt.EQ.5)THEN
CCC   for Au-Au 200 GeV
         KTmin = 0.48
         KTmax = 0.54
c      ELSE IF(ikt.EQ.6)THEN
CCC   for Au-Au 200 GeV
c         KTmin = 0.54
c         KTmax = 0.60
c      ELSE IF(ikt.EQ.7)THEN
CCC   for Au-Au 200 GeV
c         KTmin = 0.60
c         KTmax = 0.75
c      ELSE IF(ikt.EQ.8)THEN
CCC   for Au-Au 200 GeV
c         KTmin = 0.75
c         KTmax = 1.00
      ELSE IF(ikt.EQ.9)THEN
CCC   for Au-Au 200 GeV
         KTmin = 1.00
         KTmax = 2.00
      ELSE
         CYCLE  
      ENDIF
      write(cktindx,'(f4.2,a1,f4.2)')KTmin,'_',KTmax

      IF (iprnt.EQ.0) WRITE(78,*)'QS   C2'
      IF (iprnt.EQ.1) WRITE(78,*)'QS   NUMERADOR   DENOMINADOR   C2'

      qsmin    = 0.0
      qsmax    = 0.1
      nqs      = 8
      dqs      = (qsmax-qsmin)/nqs

      IF (iprnt.EQ.2) WRITE(78,'(a36,a9,a6,i3)')
     &     '---- QS_NUMERADOR_DENOMINADOR_C2_KT_',cktindx,' ---- ',nqs+1
      IF (iprnt.EQ.2) WRITE(79,'(a31,a9)')
     &     'QS_NUMERADOR_DENOMINADOR_C2_KT_',cktindx
      IF (iprnt.EQ.2) WRITE(78,'(a8)')'array  6'

      DO j=0,nqs
cxx         print*,'qs --> ',j
         qs = qsmin+j*dqs
         soma1  =  0.0   
         soma2  =  0.0   
         soma3  =  0.0
         soma4  =  0.0
         DO i=1,nmc
c---
            KT    = KTmin+(KTmax-KTmin)*ran2r(idum)
            Y     = -0.5+ran2r(idum)      ! depende da janela experimental
            qo    = delta_qo*ran2r(idum)  ! depende da janela experimental
            ql    = delta_ql*ran2r(idum)  ! depende da janela experimental
c---
            CALL fndk(KT,Y,qs,qo,ql,k1,k2)   ! calcula k1 e k2
c---
            CALL CORR(nfr,Y,k1,k2,xnum,xden,xden1,xden2)
            soma2 = soma2 + KT * xnum
            soma1 = soma1 + KT * xden
            soma3 = soma3 + KT * xden1
            soma4 = soma4 + KT * xden2
         ENDDO
         soma2 = soma2/nmc
         soma1 = soma1/nmc
         soma3 = soma3/nmc
         soma4 = soma4/nmc
         C2    = 1.0 + soma2/soma1
         IF (iprnt.EQ.0) WRITE(78,310) qs,C2
         IF (iprnt.EQ.1) WRITE(78,320)qs,soma2,soma1,C2
         IF (iprnt.EQ.2) WRITE(78,330)qs,soma2,soma1,soma3,soma4,C2
      ENDDO
      IF (iprnt.EQ.2) WRITE(78,'(a8)')'endarray'
      WRITE(78,*)
      WRITE(78,*)
      WRITE(78,*)

      IF (iprnt.EQ.0) WRITE(78,*)'QO   C2'
      IF (iprnt.EQ.1) WRITE(78,*)'QO   NUMERADOR   DENOMINADOR    C2'

      qomin    = 0.0
      qomax    = 0.1
      nqo      = 8
      dqo      = (qomax-qomin)/nqo

      IF (iprnt.EQ.2) WRITE(78,'(a36,a9,a6,i3)')
     &     '---- QO_NUMERADOR_DENOMINADOR_C2_KT_',cktindx,' ---- ',nqo+1
      IF (iprnt.EQ.2) WRITE(79,'(a31,a9)')
     &     'QO_NUMERADOR_DENOMINADOR_C2_KT_',cktindx
      IF (iprnt.EQ.2) WRITE(78,'(a8)')'array  6'

      DO j=0,nqo
cxx         print*,'qo --> ',j
         qo = qomin+j*dqo
         soma1  =  0.0   
         soma2  =  0.0
         soma3  =  0.0
         soma4  =  0.0
         DO i=1,nmc
c---
            KT    = KTmin+(KTmax-KTmin)*ran2r(idum)
            Y     = -0.5+ran2r(idum)             ! depende da janela experimental
            qs    = delta_qs*ran2r(idum)         ! depende da janela experimental
            ql    = delta_ql*ran2r(idum)         ! depende da janela experimental
c---
            CALL fndk(KT,Y,qs,qo,ql,k1,k2)   ! calcula k1 e k2
c---  
            CALL CORR(nfr,Y,k1,k2,xnum,xden,xden1,xden2)
            soma2 = soma2 + KT * xnum
            soma1 = soma1 + KT * xden
            soma3 = soma3 + KT * xden1
            soma4 = soma4 + KT * xden2
         ENDDO       
         soma2 = soma2/nmc
         soma1 = soma1/nmc
         soma3 = soma3/nmc
         soma4 = soma4/nmc
         C2    = 1.0 + soma2/soma1
         IF (iprnt.EQ.0) WRITE(78,310) qo,C2
         IF (iprnt.EQ.1) WRITE(78,320) qo,soma2,soma1,C2
         IF (iprnt.EQ.2) WRITE(78,330) qo,soma2,soma1,soma3,soma4,C2
      ENDDO
      IF (iprnt.EQ.2) WRITE(78,'(a8)')'endarray'
      WRITE(78,*)
      WRITE(78,*)
      WRITE(78,*)

      IF (iprnt.EQ.0) WRITE(78,*)'QL   C2'
      IF (iprnt.EQ.1) WRITE(78,*)'QL   NUMERADOR   DENOMINADOR    C2'

      qlmin    = 0.0
      qlmax    = 0.1
      nql      = 8
      dql      = (qlmax-qlmin)/nql

      IF (iprnt.EQ.2) WRITE(78,'(a36,a9,a6,i3)')
     &     '---- QL_NUMERADOR_DENOMINADOR_C2_KT_',cktindx,' ---- ',nql+1
      IF (iprnt.EQ.2) WRITE(79,'(a31,a9)')
     &     'QL_NUMERADOR_DENOMINADOR_C2_KT_',cktindx
      IF (iprnt.EQ.2) WRITE(78,'(a8)')'array  6'

      DO j=0,nql
cxx         print*,'ql --> ',j
         ql = qlmin+j*dql
         soma1  =  0.0   
         soma2  =  0.0
         soma3  =  0.0
         soma4  =  0.0   
         DO i=1,nmc
c---
            KT    = KTmin+(KTmax-KTmin)*ran2r(idum)
            Y     = -0.5+ran2r(idum)                 ! depende da janela experimental
            qo    = delta_qo*ran2r(idum)             ! depende da janela experimental
            qs    = delta_qs*ran2r(idum)             ! depende da janela experimental
c---
            CALL fndk(KT,Y,qs,qo,ql,k1,k2) ! calcula k1 e k2
c---  
            CALL CORR(nfr,Y,k1,k2,xnum,xden,xden1,xden2)
            soma2 = soma2 + KT * xnum
            soma1 = soma1 + KT * xden
            soma3 = soma3 + KT * xden1
            soma4 = soma4 + KT * xden2
         ENDDO       
         soma2 = soma2/nmc
         soma1 = soma1/nmc
         soma3 = soma3/nmc
         soma4 = soma4/nmc
         C2    = 1.0 + soma2/soma1
         IF (iprnt.EQ.0) WRITE(78,310) ql,C2
         IF (iprnt.EQ.1) WRITE(78,320)ql,soma2,soma1,C2
         IF (iprnt.EQ.2) WRITE(78,330)ql,soma2,soma1,soma3,soma4,C2
      ENDDO
      IF (iprnt.EQ.2) WRITE(78,'(a8)')'endarray'
      WRITE(78,*)
      WRITE(78,*)
      WRITE(78,*)

 100  CONTINUE
   
 200  CLOSE(78)
      CLOSE(79)
      WRITE(*,*)'You may need the hbt.optns file for data process.'
c============================

 300  FORMAT(1X,'#KT=[',1F6.3,',',1F6.3,']')
 310  FORMAT(1X,2F15.5)
 320  FORMAT(1X,4d20.10)
 330  FORMAT(6d20.10)

      RETURN
      END
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


CCC   #################################################################
CCC   fndk()
CCC   #################################################################
CCC   KT      [input]
CCC   Y       [input]
CCC   qs      [input]
CCC   qo      [input]
CCC   ql      [input]
CCC   k1(0:3) [output]
CCC   k2(0:3) [output]
CCC   #################################################################
CCC   last updated
CCC   #################################################################
      SUBROUTINE fndk(KT,Y,qs,qo,ql,k1,k2)     
      IMPLICIT NONE
        
      double precision KT,Y,qs,qo,ql
      double precision k1(0:3),k2(0:3)
      double precision masspi !! massa do pion
      PARAMETER (masspi=0.14)
      double precision KL
      
      KL = SQRT(masspi**2+KT**2)*SINH(Y)

      k1(1) = KT+0.5*qo
      k1(2) =    0.5*qs
      k1(3) = KL+0.5*ql
      k1(0) = SQRT(masspi**2+k1(1)**2+k1(2)**2+k1(3)**2)

      k2(1) = KT-0.5*qo
      k2(2) =   -0.5*qs
      k2(3) = KL-0.5*ql
      k2(0) = SQRT(masspi**2+k2(1)**2+k2(2)**2+k2(3)**2)

      RETURN
      END
CCC   #################################################################


CCC   #################################################################
CCC   SUBROUTINE PROGRAM: raplist.f: 
CCC   "raplist" makes a list for using List-Linked-Method  
CCC   to find freeze-out points quickly. It picks up fluid 
CCC   rapidity 'rf(3,nf)' closed to given (particle) rapidity 'y'. 
CCC   #################################################################
CCC   last updated
CCC   #################################################################
      SUBROUTINE raplist(Nfr)       
      IMPLICIT NONE 
      include 'spherio.inc'
      include 'epos.incsf'

      INTEGER Nfr,nf
      INTEGER i1,i2,imx

CCC   //////////////////////////////////////////////////
CCC   Initialization and find "almx"
      almx=0.000d+00 
      do nf=1,Nfr
         if(abs(rfrs(3,nf)).gt.almx) almx=abs(rfrs(3,nf)) 
      end do
c      do nf=1,Nfr
c         i1= INT((rfrs(3,nf)-(-almx))/dal)+1
c         DO 101 i2=i1-RL,i1+RL
c            if(i2.le.0)  goto 101 
c            if(i2.gt.LXY) goto 101
c            hda(i2)= 0
c 101     CONTINUE
c      end do  
cxx we replace the above initial zero assignment by the following hard loop, LXY boundary consistency check is carried out later
        do i1=1,LXY
           hda(i1)=0
        end do
CCC   //////////////////////////////////////////////////      
      imx= 0 
      do nf=1,Nfr          
         i1= INT((rfrs(3,nf)-(-almx))/dal)+1
         if(i1.gt.imx) imx=i1 
         lta(nf)= hda(i1)
         hda(i1)= nf 
      end do       
CCC   ###########################################################
CCC   error massages: 
      if(imx.gt.LXY) then
         open(11,file=fnnsp(1:nfnnsp),access='append')
         write(11,*)   'imx > LXY error in raplist.f \(^^:)/'
         close(11)
         stop 'SPheRIO: imx > LXY error in raplist.f'  
      end if   
CCC   ###########################################################
      RETURN 
      END 




