      DOUBLE PRECISION bbwn,e0tube,r0tube
      DOUBLE PRECISION kE !energy rescaling factor
      COMMON/ICOWN/bbwn,e0tube,r0tube,kE
      DOUBLE PRECISION e0Au,e0Pb
      PARAMETER(e0Au=30.0d0,e0Pb=414.0d0)
      DOUBLE PRECISION cetag,cetaflatAu,cetaflatPb !eta shift
      PARAMETER(cetag=0.8d0)
      PARAMETER(cetaflatAu=4.d0,cetaflatPb=6.d0)
      INTEGER AAu,APb
      PARAMETER(AAu=197,APb=207)
      DOUBLE PRECISION wAu,wPb !Deviation from sphere
      PARAMETER(wAu=0.0d0,wPb=0.0d0)
      DOUBLE PRECISION CSinAu,CSinPb !Total inecial cross section sigma_in
      PARAMETER(CSinAu=4.0d0,CSinPb=6.4d0)
      DOUBLE PRECISION RAu,RPb !Radius
      PARAMETER(RAu=6.37d0,RPb=6.8028d0)
      DOUBLE PRECISION cxiAu,cxiPb !surface thickness a
      PARAMETER(cxiAu=0.54d0,cxiPb=0.546d0)
      DOUBLE PRECISION crho0Au,crho0Pb !nucleon density at the center of nuclei
      PARAMETER(crho0Au=0.17d0,crho0Pb=0.17d0)
      DOUBLE PRECISION bimpb00,bimpb05,bimpb10,bimpb15,bimpb20
      DOUBLE PRECISION bimpb25,bimpb30,bimpb35,bimpb40,bimpb45
      DOUBLE PRECISION bimpb50,bimpb55,bimpb60,bimpb65,bimpb70
      DOUBLE PRECISION bimpb75,bimpb80,bimpb85,bimpb90
      PARAMETER(bimpb00=0.00d0*RPb,bimpb05=0.51d0*RPb)
      PARAMETER(bimpb10=0.74d0*RPb,bimpb15=0.91d0*RPb)
      PARAMETER(bimpb20=1.05d0*RPb,bimpb25=1.18d0*RPb)
      PARAMETER(bimpb30=1.29d0*RPb,bimpb35=1.39d0*RPb)
      PARAMETER(bimpb40=1.49d0*RPb,bimpb45=1.58d0*RPb)
      PARAMETER(bimpb50=1.67d0*RPb,bimpb55=1.75d0*RPb)
      PARAMETER(bimpb60=1.83d0*RPb,bimpb65=1.90d0*RPb)
      PARAMETER(bimpb70=1.97d0*RPb,bimpb75=2.06d0*RPb)
c      PARAMETER(bimpb80=2.06d0*RPb,bimpb85=2.06d0*RPb)
c      PARAMETER(bimpb90=2.06d0*RPb)
      DOUBLE PRECISION bimau00,bimau05,bimau10,bimau15,bimau20
      DOUBLE PRECISION bimau06
      DOUBLE PRECISION bimau25,bimau30,bimau35,bimau40,bimau45
      DOUBLE PRECISION bimau50,bimau55,bimau60,bimau65,bimau70
      DOUBLE PRECISION bimau75,bimau80,bimau85,bimau90
      PARAMETER(bimau00=0.000d0,bimau05=3.383d0)
      PARAMETER(bimau06=3.706d0)
      PARAMETER(bimau10=4.784d0,bimau15=5.859d0)
      PARAMETER(bimau20=6.765d0,bimau25=7.564d0)
      PARAMETER(bimau30=8.286d0,bimau35=8.950d0)
      PARAMETER(bimau40=9.568d0,bimau45=10.15d0)
      PARAMETER(bimau50=10.70d0,bimau55=11.22d0)
      PARAMETER(bimau60=11.72d0,bimau65=12.20d0)
      PARAMETER(bimau70=12.66d0,bimau75=13.10d0)
      PARAMETER(bimau80=13.53d0,bimau85=13.95d0)

      DOUBLE PRECISION bpmpb00,bpmpb05,bpmpb10,bpmpb15,bpmpb20
      DOUBLE PRECISION bpmpb25,bpmpb30,bpmpb35,bpmpb40,bpmpb45
      DOUBLE PRECISION bpmpb50,bpmpb55,bpmpb60,bpmpb65,bpmpb70
      DOUBLE PRECISION bpmpb75,bpmpb80,bpmpb85,bpmpb90
      PARAMETER(bpmpb00=0.00d0,bpmpb05=0.05d0,bpmpb10=0.10d0)
      PARAMETER(bpmpb15=0.15d0,bpmpb20=0.20d0,bpmpb25=0.25d0)
      PARAMETER(bpmpb30=0.30d0,bpmpb35=0.35d0,bpmpb40=0.40d0)
      PARAMETER(bpmpb45=0.45d0,bpmpb50=0.50d0,bpmpb55=0.55d0)
      PARAMETER(bpmpb60=0.60d0,bpmpb65=0.65d0,bpmpb70=0.70d0)
      PARAMETER(bpmpb75=0.75d0,bpmpb80=0.80d0,bpmpb85=0.85d0)
      PARAMETER(bpmpb90=0.90d0)            
      
      
